export const removeSpacesAndLinebreaks = (s: string): string => {
  const regexNewlines = new RegExp(/[\r\n\v]+/g);
  const regexSpaces = new RegExp(/\s+|\u200B/g);

  return s.replace(regexNewlines, "").replace(regexSpaces, "");
};

export const removeQRCodes = (s: string): string => {
  return s
    .replace(/\[qrcode.png\]\s*<https:\/\/[\w./?=\-&]+>/g, "")
    .replace(/<https:\/\/[\w./?=\-&]+>\s*\[qrcode.png\]/g, "");
};
